CREATE TABLE orbitale_cms_pages (id INT AUTO_INCREMENT NOT NULL, podcast_show_id BINARY(16) NOT NULL COMMENT '(DC2Type:uuid_binary_ordered_time)', category_id INT DEFAULT NULL, parent_id INT DEFAULT NULL, title VARCHAR(255) NOT NULL, slug VARCHAR(255) NOT NULL, page_content LONGTEXT DEFAULT NULL, meta_description VARCHAR(255) DEFAULT NULL, meta_title VARCHAR(255) DEFAULT NULL, meta_keywords VARCHAR(255) DEFAULT NULL, css LONGTEXT DEFAULT NULL, js LONGTEXT DEFAULT NULL, created_at DATETIME NOT NULL, enabled TINYINT(1) NOT NULL, homepage TINYINT(1) NOT NULL, host VARCHAR(255) DEFAULT NULL, locale VARCHAR(6) DEFAULT NULL, UNIQUE INDEX UNIQ_C0E694ED989D9B62 (slug), INDEX IDX_C0E694ED7A80CB6E (podcast_show_id), INDEX IDX_C0E694ED12469DE2 (category_id), INDEX IDX_C0E694ED727ACA70 (parent_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8mb4 COLLATE `utf8mb4_unicode_ci` ENGINE = InnoDB;
CREATE TABLE orbitale_cms_categories (id INT AUTO_INCREMENT NOT NULL, parent_id INT DEFAULT NULL, name VARCHAR(255) NOT NULL, slug VARCHAR(255) NOT NULL, description LONGTEXT DEFAULT NULL, enabled TINYINT(1) NOT NULL, created_at DATETIME NOT NULL, UNIQUE INDEX UNIQ_A8EF7232989D9B62 (slug), INDEX IDX_A8EF7232727ACA70 (parent_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8mb4 COLLATE `utf8mb4_unicode_ci` ENGINE = InnoDB;
CREATE TABLE fos_user (id INT AUTO_INCREMENT NOT NULL, username VARCHAR(180) NOT NULL, username_canonical VARCHAR(180) NOT NULL, email VARCHAR(180) NOT NULL, email_canonical VARCHAR(180) NOT NULL, enabled TINYINT(1) NOT NULL, salt VARCHAR(255) DEFAULT NULL, password VARCHAR(255) NOT NULL, last_login DATETIME DEFAULT NULL, confirmation_token VARCHAR(180) DEFAULT NULL, password_requested_at DATETIME DEFAULT NULL, roles LONGTEXT NOT NULL COMMENT '(DC2Type:array)', UNIQUE INDEX UNIQ_957A647992FC23A8 (username_canonical), UNIQUE INDEX UNIQ_957A6479A0D96FBF (email_canonical), UNIQUE INDEX UNIQ_957A6479C05FB297 (confirmation_token), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8mb4 COLLATE `utf8mb4_unicode_ci` ENGINE = InnoDB;
CREATE TABLE users_podcasts (user_id INT NOT NULL, podcast_show_id BINARY(16) NOT NULL COMMENT '(DC2Type:uuid_binary_ordered_time)', INDEX IDX_D548C3E5A76ED395 (user_id), INDEX IDX_D548C3E57A80CB6E (podcast_show_id), PRIMARY KEY(user_id, podcast_show_id)) DEFAULT CHARACTER SET utf8mb4 COLLATE `utf8mb4_unicode_ci` ENGINE = InnoDB;
CREATE TABLE podcast_episode (id BINARY(16) NOT NULL COMMENT '(DC2Type:uuid_binary_ordered_time)', podcast_show_id BINARY(16) NOT NULL COMMENT '(DC2Type:uuid_binary_ordered_time)', episodeNumber INT NOT NULL, episodeSeason INT DEFAULT 1 NOT NULL, episodeType VARCHAR(255) NOT NULL, title VARCHAR(255) NOT NULL, subtitle VARCHAR(255) DEFAULT NULL, summary LONGTEXT DEFAULT NULL, audio VARCHAR(255) DEFAULT NULL, image VARCHAR(255) DEFAULT NULL, released_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, published TINYINT(1) DEFAULT NULL, INDEX IDX_77EB2BD07A80CB6E (podcast_show_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8mb4 COLLATE `utf8mb4_unicode_ci` ENGINE = InnoDB;
CREATE TABLE podcast_show (id BINARY(16) NOT NULL COMMENT '(DC2Type:uuid_binary_ordered_time)', title VARCHAR(255) NOT NULL, subtitle VARCHAR(255) NOT NULL, description LONGTEXT NOT NULL, author VARCHAR(255) NOT NULL, owner_name VARCHAR(255) NOT NULL, owner_mail VARCHAR(255) NOT NULL, is_explicit TINYINT(1) NOT NULL, copyright VARCHAR(255) NOT NULL, showType VARCHAR(255) NOT NULL, slug VARCHAR(255) DEFAULT NULL, category VARCHAR(255) NOT NULL, language VARCHAR(255) NOT NULL, itunes_url VARCHAR(255) DEFAULT NULL, visible_in_website TINYINT(1) DEFAULT NULL, image VARCHAR(255) DEFAULT NULL, updated_at DATETIME DEFAULT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8mb4 COLLATE `utf8mb4_unicode_ci` ENGINE = InnoDB;
ALTER TABLE orbitale_cms_pages ADD CONSTRAINT FK_C0E694ED7A80CB6E FOREIGN KEY (podcast_show_id) REFERENCES podcast_show (id);
ALTER TABLE orbitale_cms_pages ADD CONSTRAINT FK_C0E694ED12469DE2 FOREIGN KEY (category_id) REFERENCES orbitale_cms_categories (id);
ALTER TABLE orbitale_cms_pages ADD CONSTRAINT FK_C0E694ED727ACA70 FOREIGN KEY (parent_id) REFERENCES orbitale_cms_pages (id);
ALTER TABLE orbitale_cms_categories ADD CONSTRAINT FK_A8EF7232727ACA70 FOREIGN KEY (parent_id) REFERENCES orbitale_cms_categories (id);
ALTER TABLE users_podcasts ADD CONSTRAINT FK_D548C3E5A76ED395 FOREIGN KEY (user_id) REFERENCES fos_user (id);
ALTER TABLE users_podcasts ADD CONSTRAINT FK_D548C3E57A80CB6E FOREIGN KEY (podcast_show_id) REFERENCES podcast_show (id);
ALTER TABLE podcast_episode ADD CONSTRAINT FK_77EB2BD07A80CB6E FOREIGN KEY (podcast_show_id) REFERENCES podcast_show (id);
